!c Description:
!c   ǥХå⡼. 
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2004-04-26    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2004, All rights reserved

program OboroDebug
  use gtool_history
  use dcl
  use prm_type, only: type_property
  use prm_common, only: obrinit, struct, property, emol_ini, &
       & smax, emax, pres_ini, pres_end, temp_ini, cnv, min, &
       & pseudosw, AdbtFile
  use interface_netcdf_open
  use interface_netcdf_get
  use interface_netcdf_close
  use interface_mingibbs_chk
  use interface_entropy
  use interface_gibbs_energy
  use interface_molfraction
  use interface_name_cnd2gas 
  use interface_svap_antoine
  use interface_svap_amp
  
  implicit none
  real(8), allocatable        :: pres_map(:)      
  real(8), allocatable        :: entr_map(:)
  real(8), allocatable        :: temp_map(:)
  real(8), allocatable        :: mol(:)
  real(8), allocatable        :: mol_map(:,:)
  real(8), allocatable        :: mol_tmp(:,:)
  real(8), allocatable        :: mol_store(:,:)
  real(8), allocatable        :: emol_map(:,:)
  real(8), allocatable        :: emol_tmp(:,:)
  real(8), allocatable        :: molfr(:)
  real(8), allocatable        :: molfr_store(:,:)
  real(8), allocatable        :: entr(:)
  real(8), allocatable        :: entr_store(:,:)
  real(8), parameter          :: temp_chg = -0.1d0
  real(8)                     :: temp_store(100)     
  real(8)                     :: entr_all_store(100) 
  real(8)                     :: entr_err_store(100) 
  real(8)                     :: err
  real(8)                     :: gibbs
  real(8)                     :: gibbs_store(100) 
  real(8)                     :: svap1
  real(8)                     :: temp1, temp2, temp3  
  real(8)                     :: entr1, entr2, entr3  
  real, allocatable           :: temp_plot(:)      
  real, allocatable           :: entr_plot(:,:)
  real, allocatable           :: entr_all_plot(:)
  real, allocatable           :: entr_err_plot(:)
  real, allocatable           :: gibbs_plot(:)
  real, allocatable           :: mol_plot(:,:)
  real, allocatable           :: presfr_plot(:,:)
  real, allocatable           :: svap_plot(:,:)
  real                        :: temp_bs(2), entr_bs(2)
  integer                     :: i, l, s
  integer                     :: step
  integer                     :: ncid
  integer                     :: iws
  character(10)               :: name

  
!!!
!!!ǡƤӽФ
!!!
  call obrinit


!!!
!!!NetCDF եΥץ
!!! pres, spc, elm Ǥ뤳ȤΤäƤ
!!!
  !եΥץ
  call netcdf_open(trim(AdbtFile), ncid)

  !ѿμ. Фѿ pres, spc, elm, temp, mol, molfr 
  name = 'pres'
  call netcdf_get(ncid, name, pres_map)
  name = 'temp'
  call netcdf_get(ncid, name, temp_map)
  name = 'entr'
  call netcdf_get(ncid, name, entr_map)
  name = 'mol'
  call netcdf_get(ncid, name, mol_tmp)
  name = 'emol'
  call netcdf_get(ncid, name, emol_tmp) 
  
  !γ
  step = size(pres_map)
  allocate(mol_map(step, smax), emol_map(step, emax))
  mol_map   = transpose(mol_tmp)
  emol_map  = transpose(emol_tmp)

  !եĤ
  call netcdf_close(ncid)
  
!!!
!!!֥ǾˡԤνͤ
!!!
  !ѿ
  allocate(mol(smax), mol_store(100,smax), &
       & molfr(smax), molfr_store(100, smax), &
       & entr(smax),  entr_store(100, smax))
  temp_store = 0.0d0
  mol = 0.0d0; mol_store = 0.0d0
  molfr = 0.0d0; molfr_store = 0.0d0
  entr = 0.0d0; entr_store = 0.0d0
  
  !׻Ϥ
  write(*,*) "ϤϤƲ (ƥå׿)"
  read(*,*) l

  !Ϥ줿Ϥ˶ᤤʻ
  write(*,*) "ΰϤ˴ؤƷ׻ޤ: ", pres_map(l)
  

!!!
!!!֥ͳͥ륮Ǿ
!!!
  !ƥå1: ȥԡͤ򶴤ಹ٤
  i = 0
  STEP1: do 
     !
     temp3 = temp_map(l - 1) + i * temp_chg
        
     !ȥԡη׻
     call mingibbs_chk(temp3, pres_map(l), &
          & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
     call entropy(temp3, pres_map(l), mol, property, &
          & entr=entr, entr_all = entr3)
     call gibbs_energy(temp3, pres_map(l), mol, property, gibbs=gibbs)
     call molfraction(mol, property%phase, molfr)
        
     !롼׽λ
     if (entr3 < entr_map(l-1)) then 
        exit STEP1
     end if
     
     !롼פ֤
     i = i + 1
     entr1 = entr3
     temp1 = temp3

     !ͤ¸
     err = abs(entr3 - entr_map(l-1))/entr_map(l-1)
     temp_store(i) = temp3
     entr_all_store(i) = entr3
     entr_err_store(i) = err
     gibbs_store(i) = gibbs
     entr_store(i,:) = entr(:)
     mol_store(i,:) = mol(:)
     molfr_store(i,:) = molfr(:)
  end do STEP1
     
  !ƥå 2: ٤ǤΥȥԡ, 1 ƥåǤ
  !            ȥԡƱˤʤޤǼ«.
  STEP2: do 
     !Ǥͤ׻
     temp2 = (temp1 + temp3) / 2.0d0
     
     call mingibbs_chk(temp2, pres_map(l), &
          & emol_map(l-1,:), struct, property, mol, mol_map(l-1,:))
     call entropy(temp2, pres_map(l), mol, property, &
          & entr=entr, entr_all=entr2)
     call gibbs_energy(temp2, pres_map(l), mol, property, gibbs=gibbs)
     call molfraction(mol, property%phase, molfr)

     !ͤ¸
     err = abs(entr2 - entr_map(l-1))/entr_map(l-1)
     i = i + 1
     temp_store(i) = temp2
     entr_all_store(i) = entr2
     entr_err_store(i) = err
     gibbs_store(i) = gibbs
     entr_store(i,:) = entr(:)
     mol_store(i,:) = mol(:)
     molfr_store(i,:) = molfr(:)
     
     !롼׽λ. 
     if (abs((entr2 - entr_map(l-1))/entr_map(l-1)) <= cnv) then
        write(*,*) "(", l, ") ", "Entropy is now converged" 
        exit STEP2
     end if
     
     !Ū˲٤ˤϥå. 
     if (temp1 == temp2 .OR. temp2 == temp3) then
        write(*,*) "Conserved Entropy is slightly changed", &
             & entr_map(l-1), " -> ", entr2
        write(*,*) "(", l, ") ", "Entropy is now converged" 
        exit STEP2
     end if
     
     !ƥåפʤ뤿ν
     if (entr3 < entr_map(l-1) .and. entr_map(l-1) < entr2) then
        temp1 = temp2
        entr1 = entr2
     elseif (entr2 <= entr_map(l-1) .and. entr_map(l-1) < entr1) then
        temp3 = temp2
        entr3 = entr2
     end if
  end do STEP2

  
!!!
!!!ץåȤ뤿
!!!
  step = minloc(temp_store, 1, temp_store == 0.0d0) -1

  allocate(temp_plot(step), &
       & entr_plot(step,smax), entr_err_plot(step), gibbs_plot(step), &
       & entr_all_plot(step), mol_plot(step,smax), &
       & presfr_plot(step,smax), svap_plot(step,smax))
  temp_plot = 0.0d0; entr_plot = 0.0d0
  entr_all_plot = 0.0d0; entr_err_plot = 0.0d0
  molfr = 0.0d0
  presfr_plot = 0.0d0
  svap_plot = 0.0d0
  
  temp_plot = real(temp_store(1:step), 4)
  entr_plot(:,:) = real(entr_store(1:step,:), 4)
  entr_all_plot = real(entr_all_store(1:step), 4)
  entr_err_plot = real(entr_err_store(1:step), 4)
  gibbs_plot = real(gibbs_store(1:step), 4)
  mol_plot(:,:) = real(mol_store(1:step,:), 4)
  presfr_plot(:,:) = real(molfr_store(1:step,:) * pres_map(l), 4)
  
  entr_bs = entr_map(l-1)
  temp_bs(1) = minval(temp_plot)
  temp_bs(2) = maxval(temp_plot)
  

!!!
!!!˰¾
!!!ʿվΥץåԽʬ⤷ʤ....
!!!
  PLOT: do s = 1, smax
     do i = 1, step
        if (property(s)%method == 3) then 
           call svap_amp(temp_store(i), property(s)%svap_cef, svap1)
        elseif (property(s)%method == 4) then 
           call svap_antoine(temp_store(i), property(s)%svap_cef, svap1)
        else
           cycle plot
        end if
        
!        svap_plot(i,s) = real(svap1, 4)         
        svap_plot(i,s) = real(molfr_store(i,s) * svap1, 4) 

     end do
  end do PLOT

  
!!!
!!!ͤɽ
!!!
  !դΥץ
  call DclOpenGraphics()
!  call DclDivideFrame( 'y', 3, 2 )
  call DclSetFrameMargin( 0.05, 0.05, 0.05, 0.05 )

  !պ
  call DclNewFrame
  call DclScalingPoint(temp_plot, entr_all_plot)
  call DclScalingPoint(temp_bs, entr_bs) 
  call DclFitScalingParm
  call DclSetTransFunction

  call DclSetTitle('Temperature', 'entropy', 'K', 'J/K')
  call DclDrawScaledAxis
  
  call DclDrawMarker(temp_plot, entr_all_plot, index=5)
  call DclDrawLine(temp_bs, entr_bs, index=21) 

  call DclDrawTitle( 'T', 'entropy', sw=2 )
  

  !պ
  call DclNewFrame
  call DclSetTransNumber(2)
  call DclScalingPoint(temp_plot, entr_err_plot)
  call DclFitScalingParm
  call DclSetTransFunction

  call DclSetTitle('Temperature', 'entropy error', 'K', '')
  call DclDrawScaledAxis
  call DclDrawMarker(temp_plot, entr_err_plot, index=5)
  call DclDrawTitle( 'T', 'entropy error', sw=2 )

  !պ
  call DclNewFrame
  call DclScalingPoint(temp_plot, gibbs_plot)
  call DclFitScalingParm
  call DclSetTransFunction

  call DclSetTitle('Temperature', 'gibbs', 'K', '')
  call DclDrawScaledAxis
  call DclDrawMarker(temp_plot, gibbs_plot, index=5)
  call DclDrawTitle( 'T', 'gibbs', sw=2 )

  !
  do i = 1, smax
     call DclNewFrame
     call DclScalingPoint(temp_plot, mol_plot(:,i))
     call DclFitScalingParm
     call DclSetTransFunction
     
     call DclSetTitle('Temperature', 'mol', 'K', 'mol')
     call DclDrawScaledAxis
     call DclDrawMarker(temp_plot, mol_plot(:,i), index=5)
     call DclDrawTitle( 'T', property(i)%name, sw=2 )
  end do
  
!  !ȥԡΥץå
!  do i = 1, smax
!     call DclNewFrame
!     call DclScalingPoint(temp_plot, entr_plot(:,i))
!     call DclFitScalingParm
!     call DclSetTransFunction
!     
!     call DclSetTitle('Temperature', 'K', 'entropy', 'J/K')
!     call DclDrawScaledAxis
!     call DclDrawMarker(temp_plot, entr_plot(:,i), index=5)
!     call DclDrawTitle( 'T', property(i)%name, sw=2 )
!  end do


  !ʬ. ˰¾˥ץå
  do i = 1, count(property%phase == 1)
     call DclNewFrame
     call DclSetTransNumber(1)
     call DclSetParm('INTERPRET_MISSING_VALUE', .true. )
     call DclScalingPoint(temp_plot, presfr_plot(:,i))

     do s = count(property%phase == 1) + 1, smax
        call name_cnd2gas(property(s)%name, name)
        if (trim(name) /= trim(property(i)%name)) cycle
        call DclScalingPoint(temp_plot, svap_plot(:,s))
     end do

     call DclFitScalingParm
     call DclSetTransFunction

     call DclSetTitle('Temperature', 'partial pressure', 'K', 'Pa')
     call DclDrawScaledAxis

     call DclDrawMarker(temp_plot, presfr_plot(:,i), index=5)
     do s = count(property%phase == 1) + 1, smax
        call name_cnd2gas(property(s)%name, name)
        if (trim(name) /= trim(property(i)%name)) cycle
        l = s * 10 + 2
!        call DclDrawLine(temp_plot, svap_plot(:,s), index=l) 
        call DclDrawMarker(temp_plot, svap_plot(:,s), type=2, index=l) 
     end do
     call DclDrawTitle( 'T', property(i)%name, sw=2 )
  end do


  !դΥ
  call DCLCloseGraphics


end program OboroDebug






