!c Description:
!c   ͤ˶ᤤη׻.  
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_equivmol
  interface

     subroutine EquivMol(B, struct, phase, temp, mu, mol, mol_pre)
       real(8), intent(in)     :: temp            !
       real(8), intent(inout)  :: B(:)            !
       real(8), intent(in)     :: mu(:)           !إݥƥ󥷥
       real(8), intent(in)     :: struct(:,:)     !ؼ˴ޤޤ븵ǿ
       real(8), intent(inout)  :: mol(:)          !ؼΥ
       real(8), intent(out), allocatable :: mol_pre(:)   
       integer, intent(in)  :: phase(:)        !ֹ
     end subroutine EquivMol
     
  end interface
end module interface_equivmol





subroutine equivmol(B, struct, phase, temp, mu, mol, mol_pre)
  use prm_phys, only: gasr
  use interface_phase_pack
  
  implicit none
  real(8), intent(in)     :: temp            !
  real(8), intent(inout)  :: B(:)            !
  real(8), intent(in)     :: mu(:)           !إݥƥ󥷥
  real(8), intent(in)     :: struct(:,:)     !ؼ˴ޤޤ븵ǿ
  real(8), intent(inout)  :: mol(:)          !ؼΥ
  real(8), intent(out), allocatable :: mol_pre(:)   
  integer, intent(in)     :: phase(:)        !ֹ

  real(8), allocatable    :: B_phi(:)        !
  real(8), allocatable    :: struct_dot_B(:) !struct  B 
  integer                 :: i 
  integer                 :: smax, emax
  integer, allocatable    :: phase_tmp(:)     


!!!
!!!
!!!  
  !礭
  smax = size(struct, 1)
  emax = size(struct, 2)

  !γ
  if (allocated(mol_pre)) deallocate(mol_pre)
  allocate(mol_pre(smax), &
       & B_phi(smax), &
       & struct_dot_B(smax))
  
  !ͤ
  mol_pre = mol

  allocate(phase_tmp(smax))
  phase_tmp = phase
  call phase_pack(phase_tmp)
 
  
!!!
!!!ʿ׻
!!!
  !B_phi ˤֹԤͤ
  do i = 1, smax
     B_phi(i) = B(emax+ phase_tmp(i))
  end do
  
  !struct  B ѤȤ
  do i = 1, smax
     struct_dot_B(i) = sum(B(1: emax) * struct(i, 1: emax)) 
  end do
  

!!!
!!!ʿշ׻
!!!
  !ʿη׻()
  mol = &
       & - mol * mu / (gasr * temp) &
       & + mol * B_phi & 
       & + mol * struct_dot_B
  
  
!!!  
!!!
!!!
  deallocate(B_phi, struct_dot_B, phase_tmp)
  
end subroutine equivmol





